
#ifndef PARAMS_H
#define PARAMS_H

#include <cstdlib>
using namespace std;

#include "KM-spectra/costal.h"

// acoustic to optical: old value = 57200, new value = 20-300
//const float conversion = 50000;

const double* const light = C0100_White;
const double* const absp[] = {K0300_Water,
                              K0600_Wurtzite}; // Not being used
const double* const scat[] = {S0300_Water, // Not being used
                              S0600_Wurtzite}; // Not being used
//const float reflFactorW = 0.1;

const float EPSILON = 0.003; // A very small number, for detecting opacity
const double density_min = 0.0000000001; // Assumed particle density in areas with no data
//const float scalefactor = 0.1; // voxel separation (meters)

const float c = 0.95; // H-G phase function bias
const float innerfactor = 0.861152; // inner integral of H-G function
const float outerfactor = 0.097372; // outer integral of H-G function

// const unsigned int colorLength = 3;
// const int colorInd[colorLength] = {28, 14, 7};
const unsigned int colorLength = 31;
const int colorInd[colorLength] = { 0,
                                    1, 2, 3, 4, 5, 6, 7, 8, 9,10,
                                   11,12,13,14,15,16,17,18,19,20,
                                   21,22,23,24,25,26,27,28,29,30};

#define DEBUG 5

#define X_POS 1
#define X_NEG 2
#define Y_POS 3
#define Y_NEG 4
#define Z_POS 5
#define Z_NEG 6

#endif // PARAMS_H
