#include "rtCommon/rtLightSpec.h"
#include "rtCommon/rtPoint.h"
#include <iostream>
#include <string>

void rtLightSpec::set(const rtPoint& p, const rtPoint& o,const string& s)
{
  point = p;
  look = o;
  fileName = s;
}

const string& rtLightSpec::file() const {
  return fileName;
}

int rtLightSpec::getX() const {
  return point.getX();
}

int rtLightSpec::getY() const {
  return point.getY();
}

int rtLightSpec::getZ() const {
  return point.getZ();
}

const rtPoint& rtLightSpec::position() const {
  return point;
}

const rtPoint& rtLightSpec::lookPt() const {
  return look;
}

ostream& rtLightSpec::show(ostream& s) const {
  return s << point << " " << look << " " << fileName.c_str() << " ";
}

istream& operator>>(istream& s, rtLightSpec& ls) {
  rtPoint p;
  rtPoint q;
  string str;
  s >> p >> q >> str;
  ls.set(p,q,str);
  return s;
}
