#ifndef RTLIGHTSPEC_H
#define RTLIGHTSPEC_H

#include "rtCommon/rtBase.h"
#include "rtCommon/rtPoint.h"
#include <iostream>
#include <string>

class rtLightSpec : public rtBase {
 protected:
  rtPoint point;
  rtPoint look;
  string fileName;

 public:
  rtLightSpec() {}
 rtLightSpec(const rtLightSpec& b) : rtBase(), 
    point(b.point), look(b.look), fileName(b.fileName) {}
 rtLightSpec(const rtPoint& p, const rtPoint& o, const string& s) : rtBase(),
    point(p), look(o), fileName(s) {}

  void set(const rtPoint&, const rtPoint&, const string& );
  
  const string& file() const;

  int getX() const;
  int getY() const;
  int getZ() const;
  const rtPoint& position() const;

  const rtPoint& lookPt() const;

  virtual ostream& show(ostream& ) const;
 
};

istream& operator>>(istream&, rtLightSpec& );


#endif
