#include "art.h"

void rtRay::SetLocation(const rtPoint& pt1, const rtPoint& pt2) {
  origin.Set(pt1);
  direction.Set(pt1,pt2);
}

void rtRay::SetLocation(const rtPoint& pt1, const rtVector& vec) {
  origin.Set(pt1);
  direction.Set(vec);
  direction.Normalize();
}

void rtRay::resetColors() {
  color.setValues(color.getMin());
  absorption.setValues(absorption.getMax());
  alpha = 0.0;
}

void rtRay::setColor(float r, float g, float b) {
  color.Set(r, g, b);
}
void rtRay::setColor(const vector<float>& values) {
  color.Set(values);
}
void rtRay::setColor(const rtColor& col) {
  color.Set(col);
}
void rtRay::setColorChannel(int c, float v){
  color.setChannel(c, v);
}
void rtRay::addColor(const rtColor& col) {
  color += col;
}

void rtRay::setAbs(float ar, float ag, float ab) {
  absorption.Set(ar, ag, ab);
}
void rtRay::setAbs(const vector<float>& values) {
  absorption.Set(values);
}
void rtRay::setAbs(const rtColor& col) {
  absorption.Set(col);
}
void rtRay::multAbs(const rtColor& col) {
  absorption *= col;
}

void rtRay::setAlpha(float alp) {
  alpha = alp;
}
void rtRay::addAlpha(float alp) {
  alpha += alp;
}

float rtRay::getR() const {
  return color.getR();
}
float rtRay::getG() const {
  return color.getG();
}
float rtRay::getB() const {
  return color.getB();
}
float rtRay::getColorChannel(int i) const {
//   if (color.getChannel(i) < 0)
//     cerr << "getColorChannel is the culprit!!\n";
  return color.getChannel(i);
}

float rtRay::getAR() const {
  return absorption.getR();
}
float rtRay::getAG() const {
  return absorption.getG();
}
float rtRay::getAB() const {
  return absorption.getB();
}
float rtRay::getAbsChannel(int i) const {
  return absorption.getChannel(i);
}

float rtRay::getAlpha() const {
    return alpha;
}

float rtRay::getX() const {
    return origin.getX();
}
float rtRay::getY() const {
    return origin.getY();
}
float rtRay::getZ() const {
    return origin.getZ();
}

float rtRay::getI() const {
  return direction.getI();
}
float rtRay::getJ() const {
  return direction.getJ();
}
float rtRay::getK() const {
  return direction.getK();
}

void rtRay::Normalize() {
  direction.Normalize();
}

const rtColor& rtRay::showColor() const { return color; }

const rtColor& rtRay::showAbs() const { return absorption; }

const rtVector& rtRay::getDirection() const { return direction;}

const rtColor& rtRay::getColor() const { return color; }

const rtColor& rtRay::getAbs() const { return absorption; }


