#include "art.h"
#include <math.h>    

float rtSphere::getRefraction()
{ return refraction;}
rtPoint rtSphere::getCentre()
{return centre;}
float rtSphere::getIoR()
{ return IoR;}
float rtSphere::getDiffuse()
{ return diffuse;}
rtColor rtSphere::getDiffuseColor()
{ return diffuseColor; } 
float rtSphere::getSpecular()
{ return specular;}
rtColor rtSphere::getSpecularColor()
{ return specularColor; }
float rtSphere::getSpecCoeff()
{ return specCoeff;}
float rtSphere::getTransparency()
{return transparency;}

rtColor rtSphere::getColor()
{
  return color;
}    
    
void rtSphere::setCentre(rtPoint p)         {centre = p;}
void rtSphere::setRadius(float r)           {radius = r;}
void rtSphere::setColor(rtColor c)          {color = c;}
void rtSphere::setDiffuseColor(rtColor c)   {diffuseColor = c;}
void rtSphere::setSpecularColor(rtColor c)  {specularColor = c;}
void rtSphere::setSpecCoeff(int x)          {specCoeff = x;}
void rtSphere::setDiffuse(float f)          {diffuse = f;}
void rtSphere::setSpecular(float f)         {specular = f;}
void rtSphere::setRefraction(float f)       {refraction = f;}
void rtSphere::setTransparency(float f)     {transparency = f;}
void rtSphere::setIoR(float f)              {IoR = f;}

rtPoint rtSphere::intersect(rtRay iRay, rtPoint eye)
{
    float v,mag;
    float disc,d;
    rtPoint pt;
    
    rtVector EO(eye,centre);
    mag = EO.getMagnitude();
    EO.Normalize();
    iRay.Normalize();
    v = mag*(EO.dot(iRay.getDirection()));
    disc = radius*radius - (mag*mag - v*v);
    
    if(disc > radius*radius)
	disc = radius*radius;
    
    if(disc<=0)
	{
	    pt.Set(10000,10000,10000);
	    return pt;
	}
    else
	{
	    //cout << " Have an Intersect " << endl;
	    d=sqrt(disc);
	    pt.setX(eye.getX()+ (v-d)*iRay.getDirection().getI());
	    pt.setY(eye.getY()+ (v-d)*iRay.getDirection().getJ());
	    pt.setZ(eye.getZ()+ (v-d)*iRay.getDirection().getK());
	    //pt.show();
	    return pt;
	}
}

rtPoint rtSphere::inter(rtRay iRay, rtPoint eye)
{
  float v,mag;
  float disc,d;
  rtPoint tmp;
  
  rtVector EO(eye,centre);
  mag = EO.getMagnitude();
  EO.Normalize();
  iRay.Normalize();
  v = mag*(EO.dot(iRay.getDirection()));
  disc = radius*radius - (mag*mag - v*v);
    
  if(disc > radius*radius)
    disc = radius*radius;
 
  if(disc<=0)
    {
      return rtPoint(0,0,0);
    }
  else 
    {
      d=sqrt(disc);
      tmp.setX(v-d);
      tmp.setY(v+d);
      return tmp;
    }
}

rtVector rtSphere::findNormal(rtPoint intPt)
{
    return rtVector(centre,intPt);
}

