#ifndef RTVECTOR_H
#define RTVECTOR_H

#include "rtBase.h"
#include "rtPoint.h"
#include <iostream>

class rtVector : public rtBase {
 protected:
    float i;
    float j;
    float k;
 public:
 rtVector(float ic=0, float jc=0, float kc=0) : rtBase(),
      i(ic),j(jc),k(kc)
    {}
 rtVector(rtPoint p1, rtPoint p2) : rtBase() {
      Set(p1,p2);
    }

    void Set(rtPoint, rtPoint);
    void Set(rtVector);
    float getI() const;
    float getJ() const;
    float getK() const;
    float getComponent(int) const;
    void setI(float);
    void setJ(float);
    void setK(float);
    float getMagnitude() const;
    rtVector Scale(float) const;
    void Normalize();
    rtVector operator - (rtVector v) const;
    float dot(rtVector) const;
    rtVector cross(rtVector) const;

    static rtVector cross(rtVector, rtVector);
    virtual ostream& show(ostream&) const;
};


#endif
