#include "svConfig.h"
#include <string>
#include <sstream>
#include <iostream>

svConfig::svConfig(istream& in) : Config(in) {
  istringstream buffer(buff);
  string temp;
  while (buffer >> temp) {
    if (temp == "conversion" || temp == "Conversion") {
      buffer >> conversionF;
    } else if (temp == "reflFactorW" || temp == "ReflFactorW") {
      buffer >> reflFactorWv;
    } else if (temp == "scaleFactor" || temp == "ScaleFactor") {
      buffer >> scale;
     }
  }
}


float svConfig::conversion() const {
  return conversionF;
}

float svConfig::reflFactorW() const {
  return reflFactorWv;
}

float svConfig::scaleFactor() const {
  return scale;
}


const char* svConfig::error() const {
  ostringstream errbuf;
  errbuf << Config::error();

  if (conversionF <= 0) {
    errbuf << "Incorrect conversion. ";
  }
  if (scale <= 0) {
    errbuf << "Incorrect scaleFactor. ";
  } 
  if (reflFactorWv <= 0) {
    errbuf << "Incorrect reflFactorW. ";
  }
  // observerPt isn't checked because the base rtPoint is acceptable.
  
  string errstr = errbuf.str();
  if (errstr == "") {
    return 0;
  } else {
    return errstr.c_str(); 
  }
}


void svConfig::show(ostream& stream) const {
  stream << static_cast<Config>(*this)
	 << "conversion " << conversionF << endl
	 << "reflFactorW " << reflFactorWv << endl 
	 << "scaleFactor " << scale << endl
    ;
}
