#include "ddebug.h"
#include <iostream>

DDebug::DDebug(bool a, ostream& stream) : debug(a), s(stream) {};


DDebug& DDebug::operator<<(unsigned int a ) {
  if (debug) {
    s << a; 
  }
  return *this;
}

DDebug& DDebug::operator<<(int a ) {
  if (debug) {
    s << a; 
  }
  return *this;
}

DDebug& DDebug::operator<<(unsigned long a ) {
  if (debug) {
    s << a; 
  }
  return *this;
}

DDebug& DDebug::operator<<(double a ) {
  if (debug) {
    s << a;
  }
  return *this;
}

DDebug& DDebug::operator<<(const char* a ) {
  if (debug) {
    s << a;
  }
  return *this;
}

DDebug& DDebug::operator<<(const rtBase& ref) {
  if (debug) {
    s << ref;
  }
  return *this;
}

DDebug& DDebug::operator<<(ostream& (*a) (ostream&))  {
  if (debug) {
    a(s);
  }
  return *this;
}

// direct access for those who really need it.  Mostly so that other
// classes can bring in this class and define
// DDebug& Class::operator<<(DDebug& d, const Class& o) { 
//     d.stream() << o;  return d;  
// }
// without having to modify the DDebug class and using their own 
// Class::operator<<(ostream&) method.
//
ostream& DDebug::stream() {
  return s;
}
