#include "utilities/readFile.h"
#include <cmath>
#include <fstream>



bool readFile(const string& file, unsigned int size, float*& buffer) {
  buffer = new float[size];
  if (!buffer) {
    return false;
  }

  ifstream in(file.c_str());
  in.read(reinterpret_cast<char*>(buffer), size * sizeof(float));
  in.close();

#ifdef BIGENDIAN_IN
  float ftemp;
  int j;
  char* temp = reinterpret_cast<char*>(&ftemp);
  char* marker = reinterpret_cast<char*>(buffer);
#endif
  for (unsigned int i=0; i<size; i++) {
#ifdef BIGENDIAN_IN
    ftemp = buffer[i];
    for (j=0; j<sizeof(float); j++) {
      marker[j] = temp[sizeof(float) - j - 1];
    }
    marker += sizeof(float);
#endif
    if (isnan(buffer[i]) || isinf(buffer[i])) {
      return false;
    }
  }
  return true;
}


