#ifndef VRCONFIG_H
#define VRCONFIG_H

#include "utilities/config.h"
#include "rtCommon/rtPoint.h"
#include <iostream>
#include <string>

class vrConfig : public Config {
 protected:
  string imageFileName;
  unsigned int ix, iy;
  rtPoint light;
  int enhv;
  float ambientv, diffusev, colorscalev;
  float conversionF, reflFactorWv, reflFactorMv, scale;
  const double* bgv;

 public:
  vrConfig(istream& s);

  const string& imageFile() const;
  unsigned int imageX() const;
  unsigned int imageY() const;
  const rtPoint& lightCenter() const;

  // Extra parameters
  float conversion() const;
  float reflFactorW() const;
  float reflFactorM() const;
  float scaleFactor() const;
  int enh() const;
  float ambient() const;
  float diffuse() const;
  float colorscale() const;

  virtual const char* error() const;

  virtual void show(ostream&) const;
};




#endif
